/* simplest of all:
DEFINE VARIABLE a AS HANDLE NO-UNDO.
message a::a:name.
message a:name.
message a:name:type.
message a::b.
message a::b::c.
message a::name::display. */

DEFINE VARIABLE dh AS HANDLE NO-UNDO.
DEFINE VARIABLE bh AS HANDLE NO-UNDO.
DEFINE VARIABLE qh AS HANDLE NO-UNDO.
DEFINE VARIABLE th AS HANDLE NO-UNDO.

DEFINE VARIABLE c AS CHARACTER NO-UNDO.
DEFINE VARIABLE i AS INTEGER NO-UNDO.

CREATE TEMP-TABLE th.
th:ADD-FIELDS-FROM("Customer").
th:TEMP-TABLE-PREPARE("bh-name").

dh = th:DEFAULT-BUFFER-HANDLE.
bh = dh. /* just to keep dh alive */

FOR EACH Customer NO-LOCK:
    bh:BUFFER-CREATE.
    bh:BUFFER-COPY(BUFFER Customer:HANDLE).
END.

/* CREATE DATASET dh.   -- not implemented yet in P2J */
/* dh:ADD-BUFFER(bh).   -- not implemented yet in P2J */
/* dh:ADD-BUFFER(bh:NAME). -- not working this way */

CREATE QUERY qh.
qh:SET-BUFFERS(bh).
qh:QUERY-PREPARE("FOR EACH " + bh:NAME + " WHERE id GT 2").
qh:QUERY-OPEN().
qh:GET-NEXT().

message dh::bh-name.
IF NOT qh:QUERY-OFF-END THEN
    DISPLAY 
        SKIP STRING(bh:ROWID)    LABEL "bh:ROWID"
        SKIP bh:NAME             LABEL "bh:NAME"
/*      SKIP dh::bh-name         LABEL "dh::bh-name"                                               -- Unknown node type DB_REF_NON_STATIC */
        SKIP STRING(dh::bh-name) LABEL "STRING(dh::bh-name)"
/*      SKIP dh::bh-name::NAME   LABEL "dh::bh-name::NAME"                                         -- Unknown node type DB_REF_NON_STATIC */
        SKIP STRING(dh::bh-name::NAME) + "8888"    LABEL "dh::bh-name::NAME + '8888'"
/*      SKIP bh::NAME            LABEL "bh::NAME"                                                  -- Unknown node type DB_REF_NON_STATIC */
        SKIP bh:BUFFER-FIELD("Name")                        LABEL "bh:BUFFER-FIELD('Name')"                          /* this is handle representation */
        SKIP STRING(bh:BUFFER-FIELD("Name"):BUFFER-VALUE()) LABEL "bh:BUFFER-FIELD('Name'):BUFFER-VALUE()"
/*        SKIP dh:GET-BUFFER-HANDLE("bh-name")::Nume            LABEL "dh:GET-BUFFER-HANDLE('bh-name')::Name"               -- mixed chaining not supported now */
/*        SKIP (dh::bh-name):BUFFER-FIELD("Name"):BUFFER-VALUE()  LABEL "dh::bh-name:BUFFER-FIELD('Name'):BUFFER-VALUE()"   -- mixed chaining not supported now */
/*        SKIP dh:GET-BUFFER-HANDLE("bh-name"):BUFFER-FIELD("Name"):BUFFER-VALUE()
                                LABEL "dh:GET-BUFFER-H('bh-name'):BUFFER-F('Name'):BUFFER-VALUE()"
        SKIP STRING(dh:GET-BUFFER-HANDLE("bh-name"):BUFFER-FIELD("Name"):BUFFER-VALUE())           LABEL "dh:GET-BUFFER-H('bh-name'):BUFFER-F('Name'):BUFFER-VALUE()"*/
    SKIP WITH SIDE-LABELS.
ELSE 
    DISPLAY bh:NAME "not found" SKIP.

c = bh:BUFFER-FIELD("Name"):BUFFER-VALUE().
/* i = bh:BUFFER-FIELD("Name"):BUFFER-VALUE(). */

c = bh:BUFFER-FIELD("Id"):BUFFER-VALUE().
i = bh:BUFFER-FIELD("Id"):BUFFER-VALUE().

/* c = bh:BUFFER-FIELD("Id"). */
i = bh:BUFFER-FIELD("Id").
